import d from 'highlight.js/lib/languages/d'

export function geSpanList(list, cellList) {
  const cellLength = cellList.length
  if (cellLength == 0) {
    return list
  }
  console.log(getCell(list, cellList, cellLength))
  return getCell(list, cellList, cellLength)
}
/**
 *
 * @param {*} arr
 * @param {*} list
 * @param {*} cellList
 * @param {*} cellLength
 * @param {*} level
 */
function getCell(list, cellList, cellLength) {
  let arr = []
  list.map(i => {
    let b = []
    let cList = []
    getLine(b, cellList, cellLength, 0, i[cellList[0]], {})
    if (b.length) {
      b.map(item => {
        cList.push(Object.assign({}, item, i))
      })
      arr = [...cList, ...arr]
      console.log(arr)
    } else {
      arr.push(i)
    }
  })
  return arr
}
/**
 * 获取行数据
 * @param {Array} arr - 存放行数据的数组
 * @param {Array} cellList - 单元格列表
 * @param {Number} cellLength - 单元格数量
 * @param {Number} level - 当前层级
 * @param {Object} i - 当前层级的单元格对象
 * @param {Object} mergeData - 合并后的数据
 */
function getLine(arr, cellList, cellLength, level, i, mergeData) {
  if (cellLength - 1 > level) {
    // 如果当前层级小于单元格数量减1，则继续递归获取下一级别的行数据
    let obj = JSON.parse(JSON.stringify(mergeData))
    obj[cellList[level] + 'Item'] = i.text
    if (i[cellList[level + 1]].length) {
      // 如果下一级别的单元格有值，则遍历下一级别的单元格并递归获取行数据
      i[cellList[level + 1]].map(k => {
        getLine(arr, cellList, cellLength, level + 1, k, obj)
      })
    } else {
      // 如果下一级别的单元格没有值，则直接返回
      return
    }
  } else if (cellLength - 1 == level) {
    // 如果当前层级等于单元格数量减1，则将当前行数据添加到数组中
    let obj = JSON.parse(JSON.stringify(mergeData))
    obj[cellList[level] + 'Item'] = i.text
    arr.push(obj)
  } else {
    // 如果当前层级大于单元格数量减1，则直接返回
    return
  }
  return
}
